\begin{algorithm}[H]
	\SetKw{KwOr}{or}
	\SetKwInOut{Input}{Entradas}
	\SetKwInOut{Output}{Salidas}
	\Input{
		Matriz $A \in \mathcal{M}_{N\times N}$ del sistema. %\\
		Vector $b \in \mathbb{R}^{N}$ de incógnitas. %\\
		Tolerancia $\varepsilon$ para el residuo. %\\
		Número máximo de iteraciones $n_{\text{max}}$.}
	\Output{Vector $x \in \mathbb{R}^{N}$ solución del sistema lineal.}
	\BlankLine
	\Begin{
		$x = b$ \\
		$a_p = Ax$ \\
		$r = b - a_p$ \\
		$p = r$ \\
		$r_{\text{old}} = r^\intercal \cdot r$ \\
		$i = 0$
		\\
		\While{$i < n_{\text{max}}$ \KwOr $\abs{r_{\text{old}}} < \varepsilon$}{
			$a_p = A p$ \\
			$\alpha = \frac{r_{\text{old}}}{p \cdot a_p}$ \\
			$x = x + \alpha p$ \\
			$r = r - \alpha a_p$ \\
			$r_{\text{new}} = r^\intercal \cdot r$\\
			$p = r + \frac{r_{\text{old}}}{r_{\text{new}}} p$ \\
			$r_{\text{old}} = r_{\text{new}}$\\
			$i = i + 1$
		}
	}
	\caption{Gradiente conjugado.\label{alg:conj-gradient}}
\end{algorithm}
